'use strict';

const {reportError} = require('../../core/utils');
const {WikidotPage} = require('../../models');

module.exports = async (req, res) => {
    try {
        const name = await WikidotPage.getRandomRuPageName();
        res.redirect(`http://scpfoundation.ru/${name}`);
    } catch (error) {
        res.status(500).send('Unhandled internal error, incident reported');
        reportError(error, {tags: {location: 'wikidot/random-page'}});
    }
};
