'use strict';

const {reportError} = require('./utils');
const {CommonQueue} = require('../components/queues');
const path = require('path');
const runnerPath = path.resolve(__dirname, '../', 'components/task-runner.js');

module.exports = function runWorker() {
    CommonQueue.process(runnerPath);
    CommonQueue
        .on('failed', (job, error) => {
            reportError(error, {extra: {job}});
        })
        .on('error', error => {
            reportError(error);
        });
};
