'use strict';

const {Model} = require('.');
const {wk} = require('../components/wikidot-kit');
const {enqueue, logToDiscord} = require('../core/utils');

class Branch extends Model {
    static get tableName() {
        return 'branches';
    }

    async importPages() {
        logToDiscord(`Performing pages import for wiki ${this.name}`);
        const pagesList = await wk.fetchPagesList(this.name);
        await Promise.all(pagesList.map(async pageName => {
            await enqueue('page-import', [this.name, pageName]);
        }));
    }
}

module.exports = Branch;
