'use strict';

const {knex, Model} = require('.');

class WikidotPage extends Model {
    static get tableName() {
        return 'wikidot_pages';
    }

    static upsert(page) {
        const insert = knex(WikidotPage.tableName).insert(page);
        const update = knex.queryBuilder().update(page);
        return knex.raw('? ON CONFLICT (name, wiki_name) DO ? returning *', [insert, update]).get('rows').get(0);
    }

    static getRandomRuPageName() {
        return knex.raw('SELECT name FROM wikidot_ru_random_page_view').then(r => r.rows[0].name);
    }
}

module.exports = WikidotPage;
