'use strict';

const {knex, Model} = require('.');

class WikidotUser extends Model {
    static get tableName() {
        return 'wikidot_users';
    }

    static upsert(user) {
        const insert = knex(WikidotUser.tableName).insert(user);
        const update = knex.queryBuilder().update(user);
        return knex.raw('? ON CONFLICT (uid) DO ? returning *', [insert, update]).get('rows').get(0);
    }

    static membersWithDiscordTag() {
        return knex.raw(`
            SELECT SUBSTRING(about FROM 'Discord<(.*)>') as discord_id
            FROM wikidot_users
            WHERE memberships \\? 'scp-ru' AND about LIKE '%Discord<%>%'
        `).then(result => {
            return result.rows.map(row => row['discord_id']);
        });
    }
}

module.exports = WikidotUser;
